public class RecursionTest {

    public void print( int n )
    {
        if( n <= 0 )
            System.out.println( "b" );
        else
        {
            System.out.print( "a" );
            print( n - 1 );
        }
    }

    public long factorial( int n )
    {
        return n == 1 ? n : factorial( n - 1 ) * n;
    }

    public boolean search( int n )
    {
        int data[] = { 10, 20, 15, 23 };
        return search( n, data, 0 );
    }

    public boolean search( int n, int a[], int index )
    {
        if( index == a.length - 1 )
            return a[index] == n;
        else
            return a[index] == n ? true : search( n, a, index + 1 );
    }

    public int fibonacci( int n )
    {
        if( n == 0 )
            return 0;
        else if( n == 1 )
            return 1;
        else
            return fibonacci( n - 1 ) + fibonacci( n - 2 );
    }

    public int fibonacci2( int n )
    {
        if( n == 0 || n == 1 ) return n;

        int last1 = 1, last2 = 0, fibo = 0;
        for( int i = 2; i <= n; ++i )
        {
            fibo = last1 + last2;
            last2 = last1;
            last1 = fibo;
        }

        return fibo;
    }

    public static void main( String[] args )
    {
        RecursionTest foo = new RecursionTest();
        foo.print( 10 );
        System.out.println( foo.factorial( 5 ) );

        System.out.println( foo.search( 10 ) );
        System.out.println( foo.search( 11 ) );
        System.out.println( foo.search( 23 ) );

        long startTime, endTime;

        startTime = System.currentTimeMillis();
        foo.fibonacci( 40 );
        endTime = System.currentTimeMillis();
        System.out.println( (endTime - startTime) + " milliseconds" );

        startTime = System.currentTimeMillis();
        foo.fibonacci2( 40 );
        endTime = System.currentTimeMillis();
        System.out.println( (endTime - startTime) + " milliseconds" );
    }

}
